<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Home extends CI_Controller {


	function __construct() {
        parent::__construct();
      
   
    $this->load->model('admin/select');
    $this->load->model('admin/insert');

    }

	
	public function index()
	{	
		$page = 1;
		  $cars_per_page = 10;
        $total_cars = $this->select->count_active_cars();
        $total_pages = ceil($total_cars / $cars_per_page);

        $offset = ($page - 1) * $cars_per_page;
		 $data['cars'] = $this->select->get_active_cars($cars_per_page, $offset);
		 $data['banners'] = $this->select->get_active_banners();
		 $data['total_pages'] = $total_pages;
         $data['current_page'] = $page;
		  $data['car_types'] = $this->select->get_active_car_types();
		$this->load->view('car/index', $data);
	}

	public function listings($page = 1)
	{	
		  $cars_per_page = 10;
        $total_cars = $this->select->count_active_cars();
        $total_pages = ceil($total_cars / $cars_per_page);
        $data['total_cars']= $total_cars;
        $offset = ($page - 1) * $cars_per_page;
		 $data['cars'] = $this->select->get_active_cars($cars_per_page, $offset);
		$data['total_pages'] = $total_pages;
	    $data['current_page'] = $page;
		  $data['car_types'] = $this->select->get_active_car_types();

		$this->load->view('car/car-listing', $data);
	}

	public function booking($car_id) {
        $data['car'] = $this->select->get_car_by_id($car_id);
        if ($data['car']) {
            $this->load->view('car/car-booking', $data);
        } else {
            show_404();
        }
    }

    public function register() {
    $this->load->library('form_validation');
    $this->form_validation->set_rules('name', 'Name', 'required');
    $this->form_validation->set_rules('mobile', 'Mobile', 'required');
    $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
    $this->form_validation->set_rules('password', 'Password', 'required');
    $this->form_validation->set_rules('confirm_password', 'Confirm Password', 'required|matches[password]');

    if ($this->form_validation->run() == FALSE) {
        $this->load->view('car/register');
    } else {
        $data = [
            'name' => $this->input->post('name'),
            'mobile' => $this->input->post('mobile'),
            'email' => $this->input->post('email'),
            'password' => md5($this->input->post('password')),
            'rdate' => date('Y-m-d H:i:s'),
            'status' => 1
        ];
        $this->db->insert('tbl_user', $data);
        redirect('home/login');
    }
}

public function register_ajax() {
    $this->load->library('form_validation');
    $this->form_validation->set_rules('name', 'Name', 'required');
    $this->form_validation->set_rules('mobile', 'Mobile', 'required');
    $this->form_validation->set_rules('email', 'Email', 'required|valid_email');
    $this->form_validation->set_rules('password', 'Password', 'required');
    $this->form_validation->set_rules('confirm_password', 'Confirm Password', 'required|matches[password]');

    if ($this->form_validation->run() == FALSE) {
        echo json_encode(['success' => false, 'message' => validation_errors()]);
    } else {
        $data = [
            'name' => $this->input->post('name'),
            'mobile' => $this->input->post('mobile'),
            'email' => $this->input->post('email'),
            'password' => md5($this->input->post('password')),
            'rdate' => date('Y-m-d H:i:s'),
            'status' => 1
        ];
        $this->db->insert('tbl_user', $data);
        $user_id = $this->db->insert_id();
        $this->session->set_userdata('user_id', $user_id);
        $this->session->set_userdata('name', $this->input->post('name'));
        $this->session->set_userdata('mobile', $this->input->post('mobile'));
        $this->session->set_userdata('email', $this->input->post('email'));
        echo json_encode(['success' => true, 'redirect_url' => base_url('home/onboarding')]);
    }
}



public function signup(){
	if ($this->session->userdata('user_id')) {
        redirect('home');
    }
	 $this->load->view('car/register');
}
public function login(){
	if ($this->session->userdata('user_id')) {
        redirect('home');
    }
	 $this->load->view('car/login');
}

public function login_process() {
    $this->load->library('form_validation');
    $this->form_validation->set_rules('username', 'Username or Email or Mobile', 'required');
    $this->form_validation->set_rules('password', 'Password', 'required');

    if ($this->form_validation->run() == FALSE) {
        $this->load->view('car/login');
    } else {
        $username = $this->input->post('username');
        $password = md5($this->input->post('password'));

        $this->load->model('select');
        $user = $this->select->login_user($username, $password);

        if ($user) {
            // Set session data
            $this->session->set_userdata('user_id', $user->id);
            $this->session->set_userdata('name', $user->name);
            $this->session->set_userdata('email', $user->email);
            $this->session->set_userdata('mobile', $user->mobile);
            redirect('home');
        } else {
            $this->session->set_flashdata('login_error', 'Invalid username/mobile or password');
            redirect('home/login');
        }
    }
}

public function logout() {
    // Unset user session data
    $this->session->unset_userdata('user_id');
    $this->session->unset_userdata('name');
    $this->session->unset_userdata('email');

    // Redirect to login page or home page
    redirect('home');
}

public function check_login_status() {
    if ($this->session->userdata('user_id')) {
        echo json_encode(['logged_in' => true]);
    } else {
        echo json_encode(['logged_in' => false]);
    }
}

public function process_booking() {
    if (!$this->session->userdata('user_id')) {
        // User not logged in, show registration modal
        $this->session->set_flashdata('show_register_modal', true);
        redirect('home/booking'); // Adjust this redirect to the correct booking page URL
    } else {
        // Process the booking as the user is logged in
        // Your booking process logic here
        redirect('home/onboarding'); // Redirect to onboarding after booking
    }
}

public function onboarding() {
        $data['email'] = $this->session->userdata('email');
        $data['mobile'] = $this->session->userdata('mobile');
        $this->load->view('car/onboarding', $data);
}




}
